unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GLPolyhedron, GLScene, GLObjects, GLCoordinates, GLCrossPlatform,
  BaseClasses, GLWin32Viewer, ComCtrls, ExtCtrls, StdCtrls, GLGeomObjects,
  AsyncTimer;

type
  TForm1 = class(TForm)
    GLSceneViewer1: TGLSceneViewer;
    GLScene1: TGLScene;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    GLPlane1: TGLPlane;
    GLDummyCube1: TGLDummyCube;
    GLDodecahedron1: TGLDodecahedron;
    GLSphere1: TGLSphere;
    Panel1: TPanel;
    TrackBar1: TTrackBar;
    Button1: TButton;
    Label1: TLabel;
    GLCapsule1: TGLCapsule;
    AsyncTimer1: TAsyncTimer;
    procedure GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure TrackBar1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AsyncTimer1Timer(Sender: TObject);
  private
    { Private declarations }
    px,py   : integer;
    omega,t : single;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  omega := 2*Pi/(5*25);
  AsyncTimer1.Interval := 40; // milisegundos
  GLCapsule1.Position.Z := 1.5;
  t := 0;
end;

procedure TForm1.GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  px := X;
  py := Y;
end;

procedure TForm1.GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if ssLeft in Shift then begin
    GLCamera1.MoveAroundTarget(py-Y,px-X);
    px := X;
    py := Y;
  end;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
var
  L : single;
begin
  L := TrackBar1.Position/50;
  GLLightSource1.Diffuse.SetColor(L,L,L);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if Button1.Caption = '>>'
    then begin
      Button1.Caption := '||';
      AsyncTimer1.Enabled := true;
    end
    else begin
      Button1.Caption := '>>';
      AsyncTimer1.Enabled := false;
    end;

end;

procedure TForm1.AsyncTimer1Timer(Sender: TObject);
begin
  GLCapsule1.Position.X := 1.75*sin(omega*t);
  GLCapsule1.Position.Y := 1.75*cos(omega*t);
  t := t + 1;
end;

end.
